if [ $# -ne 23 ]
then
    min_items=100
    max_items=200
    min_gen_cust=50
    max_gen_cust=100
    f_a_gen_cust=0.3
    min_gen_prod=1
    max_gen_prod=5
    f_d_gen_prod=0.8
    f_a_gen_prod=0.3
    min_gen_ship=1
    max_gen_ship=10
    f_d_gen_ship=0.8
    f_a_gen_ship=0.3
    theta_int_monitor=3600
    t_int_monitor=600
    t_send_ord=600
    t_man_min_st=600
    t_man_ord=1
    num=1
    dir_res=logs
    result_file=`pwd`"/$dir_res/$num/monitor_log.csv"
    H=$((4*24*3600))
    db_online_stats=0 #don't change this
    all_args="$min_items $max_items $min_gen_cust $max_gen_cust $f_a_gen_cust $min_gen_prod $max_gen_prod $f_d_gen_prod $f_a_gen_prod $min_gen_ship $max_gen_ship $f_d_gen_ship $f_a_gen_ship $theta_int_monitor $t_int_monitor $t_send_ord $t_man_min_st $t_man_ord $num $dir_res $result_file $H $db_online_stats"
else
    all_args=$*
    min_items=$1
    shift 1
    max_items=$1
    shift 1
    min_gen_cust=$1
    shift 1
    max_gen_cust=$1
    shift 1
    f_a_gen_cust=$1
    shift 1
    min_gen_prod=$1
    shift 1
    max_gen_prod=$1
    shift 1
    f_d_gen_prod=$1
    shift 1
    f_a_gen_prod=$1
    shift 1
    min_gen_ship=$1
    shift 1
    max_gen_ship=$1
    shift 1
    f_d_gen_ship=$1
    shift 1
    f_a_gen_ship=$1
    shift 1
    theta_int_monitor=$1
    shift 1
    t_int_monitor=$1
    shift 1
    t_send_ord=$1
    shift 1
    t_man_min_st=$1
    shift 1
    t_man_ord=$1
    shift 1
    num=$1
    shift 1
    dir_res=$1
    shift 1
    result_file=$1
    shift 1
    H=$1
    shift 1
    db_online_stats=$1
fi
args_names="min_items max_items min_gen_cust max_gen_cust f_a_gen_cust min_gen_prod max_gen_prod f_d_gen_prod f_a_gen_prod min_gen_ship max_gen_ship f_d_gen_ship f_a_gen_ship theta_int_monitor t_int_monitor t_send_ord t_man_min_st t_man_ord num dir_res result_file H db_online_stats"

port_redis=6379
port_psql=5432
# psql_command="/usr/app/postgresql-15.0/build/exec_prefix/bin/psql -p $port_psql"
# pg_dump_command="/usr/app/postgresql-15.0/build/exec_prefix/bin/pg_dump -p $port_psql"
# redis_cli_command="/usr/app/redis-stable/build/bin/redis-cli -p $port_redis"
psql_command="psql -p $port_psql"
pg_dump_command="pg_dump -p $port_psql"
redis_cli_command="redis-cli -p $port_redis"

function launch_exec ()
{
    log=$1
    shift 1
    log_time=$1
    shift 1
    log_kill=$1
    shift 1
    /usr/bin/time -v -o $log_time $* > $log 2>&1 &
    echo $! >> $log_kill
}

function create_db ()
{
    res=`$psql_command --list | awk 'FNR >= 3 && $1 == "'${1}'"{print "ok"}'`
    if [ "$res" == "ok" ]
    then
	$psql_command template1 > $3 2>&1 <<< "drop database $1;"
	$psql_command template1 >> $3 2>&1 <<< "drop role ${1}_user;"
    fi
    cat $2 | $psql_command template1 >> $3 2>&1
}

function fill_dbs ()
{
    test -f init_tables.txt || { echo Unable to find init_tables.txt; exit; }
    grep "INSERT INTO item" init_tables.txt | $psql_command main_db_website
    grep "INSERT INTO function_time" init_tables.txt | $psql_command env_db_website
}

mkdir -p $dir_res/$num
pushd src > /dev/null
files_repl=$(grep -l "define DB_ONLINE_STATS" `find . -type f `)
for f in $files_repl
do
    cat $f | sed -e 's/define DB_ONLINE_STATS 0/define DB_ONLINE_STATS '$db_online_stats'/' > $f.tmptmp
    mv $f.tmptmp $f
done
bash make.sh cleanall
bash make.sh
for direct in system/*
do
    test "`basename $direct`" == "psql" && continue
    test -x $direct/bin/main || { echo Missing $direct/bin/main; exit; }
done
for direct in environment/*
do
    test "`basename $direct`" == "psql" && continue
    awk '{if ($0 == "SIMULATION_MODE = True") print "SIMULATION_MODE = False"; else print}' common_lib/common_lib.py > $direct/src/common_lib.py || { echo Unable to copy common_lib.py inside $direct; exit; }
    test -f $direct/src/main.py || { echo Missing $direct/src/main.py; exit; }
done
cat > config.txt <<EOF
env_db_website
env_db_website_user
env_db_website_user_password
127.0.0.1
$port_psql
EOF
popd > /dev/null

create_db main_db_website src/system/psql/db.sql $dir_res/$num/psql.main.log
create_db env_db_website src/environment/psql/db.sql $dir_res/$num/psql.env.log
fill_dbs
$redis_cli_command <<< FLUSHALL
awk '{if (FNR == 1) save = $0; else {print "Launched with ", $0; print "Unpacking:"; split(save, a); for (i = 1; i <= NF; i++) print a[i]" = "$i;}}' <(echo $args_names; echo $all_args) > $dir_res/$num/params.log
rm -f $dir_res/$num/kill_these.$num.log
now=`pwd`
pushd src > /dev/null
#system
launch_exec $now/$dir_res/$num/single_handle_from_work.collect_from_cust.log $now/$dir_res/$num/single_handle_from_work.collect_from_cust.time.log $now/$dir_res/$num/kill_these.log system/single_handle_from_work/bin/main collect_from_cust 127.0.0.1 $port_redis main_db_website main_db_website_user main_db_website_user_password 127.0.0.1 $port_psql unused
launch_exec $now/$dir_res/$num/single_handle_from_work.collect_from_prod.log $now/$dir_res/$num/single_handle_from_work.collect_from_prod.time.log $now/$dir_res/$num/kill_these.log system/single_handle_from_work/bin/main collect_from_prod 127.0.0.1 $port_redis main_db_website main_db_website_user main_db_website_user_password 127.0.0.1 $port_psql unused
launch_exec $now/$dir_res/$num/single_handle_from_work.collect_from_ship.log $now/$dir_res/$num/single_handle_from_work.collect_from_ship.time.log $now/$dir_res/$num/kill_these.log system/single_handle_from_work/bin/main collect_from_ship 127.0.0.1 $port_redis main_db_website main_db_website_user main_db_website_user_password 127.0.0.1 $port_psql unused
launch_exec $now/$dir_res/$num/single_handle_from_work.manage_min_storage.log $now/$dir_res/$num/single_handle_from_work.manage_min_storage.time.log $now/$dir_res/$num/kill_these.log system/single_handle_from_work/bin/main manage_min_storage 127.0.0.1 $port_redis main_db_website main_db_website_user main_db_website_user_password 127.0.0.1 $port_psql $t_man_min_st
launch_exec $now/$dir_res/$num/single_handle_from_work.manage_orders.log $now/$dir_res/$num/single_handle_from_work.manage_orders.time.log $now/$dir_res/$num/kill_these.log system/single_handle_from_work/bin/main manage_orders 127.0.0.1 $port_redis main_db_website main_db_website_user main_db_website_user_password 127.0.0.1 $port_psql $t_man_ord
launch_exec $now/$dir_res/$num/single_handle_from_work.send_orders.log $now/$dir_res/$num/single_handle_from_work.send_orders.time.log $now/$dir_res/$num/kill_these.log system/single_handle_from_work/bin/main send_orders 127.0.0.1 $port_redis main_db_website main_db_website_user main_db_website_user_password 127.0.0.1 $port_psql $t_send_ord
launch_exec $now/$dir_res/$num/int_monitor.log $now/$dir_res/$num/int_monitor.time.log $now/$dir_res/$num/kill_these.log system/int_monitor/bin/main 127.0.0.1 $port_redis main_db_website main_db_website_user main_db_website_user_password 127.0.0.1 $port_psql $result_file $theta_int_monitor $t_int_monitor
#environment
launch_exec $now/$dir_res/$num/generator.customer.log $now/$dir_res/$num/generator.customer.time.log $now/$dir_res/$num/kill_these.log python3 environment/generator/src/main.py -p customer -w $min_gen_cust -W $max_gen_cust -F $f_a_gen_cust -r $RANDOM -o "DELETE_THIS-m|$min_items|-M|$max_items" -d $now/$dir_res/$num/ 127.0.0.1 $port_redis 
launch_exec $now/$dir_res/$num/generator.producer.log $now/$dir_res/$num/generator.producer.time.log $now/$dir_res/$num/kill_these.log python3 environment/generator/src/main.py -p producer -w $min_gen_prod -W $max_gen_prod -f $f_d_gen_prod -F $f_a_gen_prod -r $RANDOM -d $now/$dir_res/$num/ 127.0.0.1 $port_redis 
launch_exec $now/$dir_res/$num/generator.shipper.log $now/$dir_res/$num/generator.shipper.time.log $now/$dir_res/$num/kill_these.log python3 environment/generator/src/main.py -p shipper -w $min_gen_ship -W $max_gen_ship -f $f_d_gen_ship -F $f_a_gen_ship -r $RANDOM -d $now/$dir_res/$num/ 127.0.0.1 $port_redis
sleep $H &
to_kill=$!
echo -e Type"\n"kill -9 $to_kill "\n"to kill all processes
wait $to_kill
popd > /dev/null
bash kill_after_run.sh $dir_res/$num/ > $dir_res/$num/kill_after_run.sh.log 2>&1
