#include <hiredis/hiredis.h>
#include <string.h>
#include <stdlib.h>
#include "clib.h"
#include <assert.h>
#include <math.h>
#include <stdarg.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <string.h>
#include<sys/socket.h>
#include<errno.h> //For errno - the error number
#include<netdb.h>	//hostent
#include<arpa/inet.h>
#include <random>
#include <pqxx/pqxx>
#include <time.h>
#include <map>

#define DBG_HERE 0
#define BUF_SIZE (1 << 21)
static char sql[BUF_SIZE], other[BUF_SIZE];

static double pseudo_barrier(redisContext *conn, double t);
static void advance_time(double t);
static double curr_time_d = -1, start_time_d, advance_elapsed_glob;
static time_t starting_t;
int init_rand_seed, num_excl_glob;
char *glob_fun_name = (char *)0, **excl_glob = (char **)0, options_before_glob = 0, options_also_barrier_glob = 0, options_also_answer_glob = 0, options_always_after_even_if_empty_glob = 0;
pqxx::connection *glob_C, *glob_C_full_log;
static redisReply *redis_cmd_wrap_psql_only_internal(redisContext *conn, int also_wrap, const char *fmt, ...);

#define FROM_VARIADIC_TO_ARGV(fmt) {\
  va_list arg;\
  char *tmp[3];\
  tmp[0] = strdup(fmt);\
  argc = 0;\
  for (tmp[1] = strtok_r(tmp[0], " ", &tmp[2]); tmp[1]; tmp[1] = strtok_r((char *)0, " ", &tmp[2]), argc++) ;\
  free(tmp[0]);\
  argv = (char **)calloc(argc, sizeof(char *));\
  unsigned *argv_len = (unsigned *)calloc(argc, sizeof(unsigned));\
  argc = 0;\
  tmp[0] = strdup(fmt);\
  va_start(arg, fmt);\
  for (tmp[1] = strtok_r(tmp[0], " ", &tmp[2]); tmp[1]; tmp[1] = strtok_r((char *)0, " ", &tmp[2]), argc++) {\
    if (strchr(tmp[1], '%')) {\
      for (int i = 0; i < strlen(tmp[1]); i++) {\
	if (tmp[1][i] == '%') {\
	  if (tmp[1][i + 1] == 's') \
	    argv_len[argc] += strlen(va_arg(arg, char *));\
	  else if (tmp[1][i + 1] == 'd') \
	    argv_len[argc] += snprintf((char *)0, 0, "%d", va_arg(arg, int));\
	  else if (tmp[1][i + 1] == 'l') {\
	    if (tmp[1][i + 2] == 'l') {\
	      argv_len[argc] += snprintf((char *)0, 0, "%lld", va_arg(arg, long long int));\
	      i += 2;\
	    }\
	    else {\
	      argv_len[argc] += snprintf((char *)0, 0, "%lf", va_arg(arg, double));\
	      i++;\
	    }\
	  }\
	  else \
	    argv_len[argc] += snprintf((char *)0, 0, "%u", va_arg(arg, unsigned));\
	  i++;\
	}\
	else\
	  argv_len[argc]++;\
      }\
    }\
  }\
  va_end(arg);\
  free(tmp[0]);\
  argc = 0;\
  tmp[0] = strdup(fmt);\
  va_start(arg, fmt);\
  for (tmp[1] = strtok_r(tmp[0], " ", &tmp[2]); tmp[1]; tmp[1] = strtok_r((char *)0, " ", &tmp[2]), argc++) {\
    if (!strchr(tmp[1], '%')) \
      argv[argc] = strdup(tmp[1]);\
    else {\
      argv[argc] = (char *)calloc(argv_len[argc] + 1, sizeof(char));\
      for (int i = 0; i < strlen(tmp[1]); i++) {\
	if (tmp[1][i] == '%') {\
	  if (tmp[1][i + 1] == 's')\
	    sprintf(&argv[argc][strlen(argv[argc])], "%s", va_arg(arg, char *));\
	  else if (tmp[1][i + 1] == 'd')\
	    sprintf(&argv[argc][strlen(argv[argc])], "%d", va_arg(arg, int));\
	  else if (tmp[1][i + 1] == 'l') {\
	    if (tmp[1][i + 2] == 'l') {\
	      sprintf(&argv[argc][strlen(argv[argc])], "%lld", va_arg(arg, long long int));\
	      i += 2;\
	    }\
	    else {\
	      sprintf(&argv[argc][strlen(argv[argc])], "%lf", va_arg(arg, double));\
	      i++;\
	    }\
	  }\
	  else \
	    sprintf(&argv[argc][strlen(argv[argc])], "%u", va_arg(arg, unsigned));\
	  i++;\
	}\
	else\
	  sprintf(&argv[argc][strlen(argv[argc])], "%c", tmp[1][i]);\
      }\
    }\
  }\
  free(argv_len);\
  va_end(arg);\
  free(tmp[0]);\
}

static void also_send_to_psql(const char *ba, const char *str)
{
  for (int i = 0; i < num_excl_glob; i++) {
    // there should not be REDIS commands which are prefix of other REDIS commands (this is false for postfixes, but we need prefixes)
    if (strstr(str, excl_glob[i]) == str) {
      // printf("DBG: On %s, found %s\n", str, excl[i]);
      return;
    }
  }
  struct timespec tv;
  clock_gettime(CLOCK_REALTIME, &tv);
  if (curr_time_d == -1)
    assert(sprintf(sql, "INSERT INTO full_log (ts_exec, ts_epoch, ts, from_function, fulltext) VALUES (%ld.%ld, extract(epoch from now()), now() at time zone 'UTC', '%s', '%s %s')", tv.tv_sec, tv.tv_nsec, glob_fun_name? glob_fun_name : "barrier", ba, str) < BUF_SIZE);
  else
    assert(sprintf(sql, "INSERT INTO full_log (ts_exec, ts_epoch, ts, inside_elapsed, inside_timestamp, from_function, fulltext) VALUES (%ld.%ld, extract(epoch from now()), now() at time zone 'UTC', %lf, CAST(TO_TIMESTAMP(%lf) AS TIMESTAMP WITHOUT TIME ZONE), '%s', '%s %s')", tv.tv_sec, tv.tv_nsec, curr_time_d - start_time_d, curr_time_d, glob_fun_name, ba, str) < BUF_SIZE);
  pqxx::work W(*glob_C_full_log);
  W.exec(sql);
  W.commit();
}

static void also_send_to_psql_argv(const char *ba, int argc, const char **argv)
{
  int dim = 0;
  for (int i = 0; i < argc; i++)
    dim += strlen(argv[i]) + 1;
  char *to_pass = (char *)calloc(dim + 1, sizeof(char ));
  for (int i = 0; i < argc; i++) {
    strcat(to_pass, argv[i]);
    strcat(to_pass, " ");
  }
  also_send_to_psql(ba, to_pass);
  free(to_pass);
}

static redisReply *redis_cmd_wrap_psql_only_argv(redisContext *conn, int also_wrap, int argc, char **argv)
{
  if (also_wrap && options_before_glob)
    also_send_to_psql_argv("before", argc, (const char **)argv);
  redisReply *ret = (redisReply *)redisCommandArgv(conn, argc, (const char **)argv, (size_t *)0);
  if (also_wrap && (strcmp(argv[0], "RPOP") != 0 || options_always_after_even_if_empty_glob || ret->type != REDIS_REPLY_NIL)) {
    static char an[] = "after but empty";
    an[strlen("after")] = (strcmp(argv[0], "RPOP") != 0 || ret->type != REDIS_REPLY_NIL)? '\0' : ' ';
    if (options_also_answer_glob && (strcmp(argv[0], "BRPOP") == 0 || (strcmp(argv[0], "RPOP") == 0 && ret->type != REDIS_REPLY_NIL))) {
      char *recv_s;
      if (strcmp(argv[0], "BRPOP") == 0)
	recv_s = strdup(ret->element[1]->str);
      else if (ret->elements == 0)
	recv_s = strdup(ret->str);
      else {
	unsigned dim = 0, i;
	for (i = 0; i < ret->elements; i++)
	  dim += strlen(ret->element[i]->str) + 3;
	recv_s = (char *)calloc(dim + 1, sizeof(char));
	for (i = 0; i < ret->elements; i++) {
	  strcat(recv_s, ret->element[i]->str);
	  strcat(recv_s, "|||");
	}
      }
      char *new_s = (char *)calloc(strlen(argv[argc - 1]) + strlen(" RECV: ") + strlen(recv_s) + 1, sizeof(char));
      sprintf(new_s, "%s RECV: %s", argv[argc - 1], recv_s);
      free(recv_s);
      free(argv[argc - 1]);
      argv[argc - 1] = new_s;
      also_send_to_psql_argv(an, argc, (const char **)argv);
    }
    else
      also_send_to_psql_argv(an, argc, (const char **)argv);
  }
  return ret;
}

// if called with function != 0, must be preceded by set_env()
void init_time(redisContext *conn, char also_register, const char *function, ...)
{
#ifdef SIMULATION_MODE
  if (function) {
    double starting_adv = 0;
    va_list arg;
    va_start(arg, function);
    int dim = vsnprintf((char *)0, 0, function, arg);
    va_end(arg);
    glob_fun_name = (char *)calloc(dim + 1, sizeof(char ));
    va_start(arg, function);
    vsprintf(glob_fun_name, function, arg);
    va_end(arg);
    char *tmp2, *tmp, *for_strtok_r;
    FILE *stream = fopen(CONFIG_FILE_PATH, "r");
    size_t r = fread(sql, sizeof(char), BUF_SIZE, stream);
    fclose(stream);
    sql[r] = '\0';
    tmp2 = strtok_r(sql, "\n", &for_strtok_r);
    assert(sprintf(other, "dbname = %s", tmp2) < BUF_SIZE);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    assert(sprintf(&other[strlen(other)], " user = %s", tmp2) < BUF_SIZE);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    assert(sprintf(&other[strlen(other)], " password = %s", tmp2) < BUF_SIZE);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    char *host = hostname_to_ip(tmp2);
    assert(sprintf(&other[strlen(other)], " hostaddr = %s", host) < BUF_SIZE);
    free(host);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    assert(sprintf(&other[strlen(other)], " port = %s", tmp2) < BUF_SIZE);
    glob_C = new pqxx::connection(other);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    assert(sprintf(other, "dbname = %s", tmp2) < BUF_SIZE);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    assert(sprintf(&other[strlen(other)], " user = %s", tmp2) < BUF_SIZE);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    assert(sprintf(&other[strlen(other)], " password = %s", tmp2) < BUF_SIZE);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    host = hostname_to_ip(tmp2);
    assert(sprintf(&other[strlen(other)], " hostaddr = %s", host) < BUF_SIZE);
    free(host);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    assert(sprintf(&other[strlen(other)], " port = %s", tmp2) < BUF_SIZE);
    glob_C_full_log = new pqxx::connection(other);
    for (tmp2 = strtok_r((char *)0, "\n", &for_strtok_r); tmp2 && strcmp(tmp2, "EXCL") != 0 && strcmp(tmp2, "OPTIONS") != 0; tmp2 = strtok_r((char *)0, "\n", &for_strtok_r)) {
      if (strncmp(glob_fun_name, tmp2, strlen(glob_fun_name)) == 0 && tmp2[strlen(glob_fun_name)] == '=') {
	init_rand_seed = atoi(&tmp2[strlen(glob_fun_name) + 1]);
      }
    }
    if (tmp2 && strcmp(tmp2, "OPTIONS") == 0) {
      tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
      options_before_glob = tmp2[0] - '0';
      options_also_barrier_glob = tmp2[1] - '0';
      options_also_answer_glob = tmp2[2] - '0';
      options_always_after_even_if_empty_glob = tmp2[3] - '0';
      // printf("DBG: %d %d %s\n", options_before_glob, options_also_barrier_glob, tmp2); fflush(stdout);
      tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    }
    num_excl_glob = 0;
    if (tmp2) {
      tmp = tmp2;
      for (tmp2 = strtok_r((char *)0, "\n", &for_strtok_r); tmp2; tmp2 = strtok_r((char *)0, "\n", &for_strtok_r)) 
	num_excl_glob++;
      if (num_excl_glob) {
	excl_glob = (char **)calloc(num_excl_glob, sizeof(char *));
	tmp += strlen(tmp) + 1; //it was on "EXCL"
	for (int i = 0; i < num_excl_glob; i++) {
	  excl_glob[i] = strdup(tmp);
	  tmp += strlen(tmp) + 1;
	}
      }
    }
    redisReply *reply;
    if (also_register) {
      reply = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, options_also_barrier_glob, "LPUSH %s %s%s", QUEUE_INIT_BARR_SEND, QUEUE_PREFIX, glob_fun_name);
      freeReplyObject(reply);
    }
    reply = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, options_also_barrier_glob, "BRPOP %s%s_1 0", QUEUE_PREFIX, glob_fun_name);
    tmp = strdup(reply->element[1]->str);
    freeReplyObject(reply);
    tmp2 = strtok_r(tmp, " ", &for_strtok_r);
    starting_t = (time_t)atol(tmp2);
    tmp2 = strtok_r((char *)0, " ", &for_strtok_r);
    starting_adv = (double)atof(tmp2);
    free(tmp);
    start_time_d = curr_time_d = (double)starting_t;
    advance_elapsed_glob = 0;
    advance_time(starting_adv);
  }
  else {
    starting_t = time((time_t *)0);
    start_time_d = curr_time_d = (double)starting_t;
    glob_fun_name = strdup("barrier");
    char *tmp2, *tmp, *for_strtok_r;
    FILE *stream = fopen(CONFIG_FILE_PATH, "r");
    size_t r = fread(sql, sizeof(char), BUF_SIZE, stream);
    fclose(stream);
    sql[r] = '\0';
    tmp2 = strtok_r(sql, "\n", &for_strtok_r);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    assert(sprintf(other, "dbname = %s", tmp2) < BUF_SIZE);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    assert(sprintf(&other[strlen(other)], " user = %s", tmp2) < BUF_SIZE);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    assert(sprintf(&other[strlen(other)], " password = %s", tmp2) < BUF_SIZE);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    char *host = hostname_to_ip(tmp2);
    assert(sprintf(&other[strlen(other)], " hostaddr = %s", host) < BUF_SIZE);
    free(host);
    tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    assert(sprintf(&other[strlen(other)], " port = %s", tmp2) < BUF_SIZE);
    glob_C_full_log = new pqxx::connection(other);
    for (tmp2 = strtok_r((char *)0, "\n", &for_strtok_r); tmp2 && strcmp(tmp2, "EXCL") != 0 && strcmp(tmp2, "OPTIONS") != 0; tmp2 = strtok_r((char *)0, "\n", &for_strtok_r));
    num_excl_glob = 0;
    if (tmp2 && strcmp(tmp2, "OPTIONS") == 0) {
      tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
      options_before_glob = tmp2[0] - '0';
      options_also_barrier_glob = tmp2[1] - '0';
      options_also_answer_glob = tmp2[2] - '0';
      options_always_after_even_if_empty_glob = tmp2[3] - '0';
      // printf("DBG: %d %d %s\n", options_before_glob, options_also_barrier_glob, tmp2); fflush(stdout);
      tmp2 = strtok_r((char *)0, "\n", &for_strtok_r);
    }
    if (tmp2) {
      tmp = tmp2;
      for (tmp2 = strtok_r((char *)0, "\n", &for_strtok_r); tmp2; tmp2 = strtok_r((char *)0, "\n", &for_strtok_r)) 
	num_excl_glob++;
      if (num_excl_glob) {
	excl_glob = (char **)calloc(num_excl_glob, sizeof(char *));
	tmp += strlen(tmp) + 1; //it was on "EXCL"
	for (int i = 0; i < num_excl_glob; i++) {
	  excl_glob[i] = strdup(tmp);
	  tmp += strlen(tmp) + 1;
	}
      }
    }
  }
  // printf("Starting time: %ld\n", starting_t);
  // fflush(stdout);
#endif
}

void terminate_time(redisContext *conn)
{
#ifdef SIMULATION_MODE
  redisReply *reply = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, options_also_barrier_glob, "LPUSH %s%s_0 TERM", QUEUE_PREFIX, glob_fun_name);
  freeReplyObject(reply);
  reply = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, options_also_barrier_glob, "BRPOP %s%s_1 0", QUEUE_PREFIX, glob_fun_name);
  freeReplyObject(reply);
#endif
}

time_t get_time()
{
  return starting_t;
}

static void advance_time(double t)
{
  // if (glob_fun_name && strcmp(glob_fun_name, "wb_generic_manage_orders") == 0) { //DBGDBGDBG
  //   printf("advance_time %lf\n", t);
  //   fflush(stdout);
  // }    
  curr_time_d = start_time_d + t;
}

char *get_curr_time_psql()
{
#ifdef SIMULATION_MODE
  assert(sprintf(sql, "CAST(TO_TIMESTAMP(%lf) AS TIMESTAMP WITHOUT TIME ZONE)", curr_time_d + advance_elapsed_glob) < BUF_SIZE);
  return sql;
#else
  assert(sprintf(sql, "CAST(now() AS TIMESTAMP WITHOUT TIME ZONE)") < BUF_SIZE);
  return sql;
#endif
}

redisContext *conn_to_redis(char **argv)
{
  const char *hostname = argv[1];
  const int port = atoi(argv[2]);
  struct timeval timeout = { 1, 500000 }; // 1.5 seconds
  redisContext *conn = redisConnectWithTimeout(hostname, port, timeout);
  if (conn == NULL || conn->err) {
    if (conn) {
      printf("Connection error: %s\n", conn->errstr);
      redisFree(conn);
    } else {
      printf("Connection error: can't allocate redis context\n");
    }
    exit(1);
  }
  return conn;
}

void from_double_to_timespec(struct timespec *req, double t)
{
  req->tv_sec = (time_t)floor(t);
  req->tv_nsec = ((long)(((t - floor(t)))*1000000000L))%1000000000L;
}

void print_all(int dbg, const char *str, ...)
{
  if (dbg) {
    struct timespec tv;
    clock_gettime(CLOCK_MONOTONIC, &tv);
    printf("%ld.%ld: ", tv.tv_sec, tv.tv_nsec);
    va_list arg;
    va_start(arg, str);
    vprintf(str, arg);
    va_end(arg);
    fflush(stdout);
  }
}

char *hostname_to_ip(const char * hostname)
{
  struct hostent *he;
  struct in_addr **addr_list;
  int i;
		
  if ( (he = gethostbyname( hostname ) ) == NULL) 
    {
      // get the host info
      printf("Argument of hostname_to_ip: %s\n", hostname); fflush(stdout);
      herror("gethostbyname");
      return (char *)0;
    }

  addr_list = (struct in_addr **) he->h_addr_list;
	
  for(i = 0; addr_list[i] != NULL; i++) 
    {
      //Return the first one;
      return strdup(inet_ntoa(*addr_list[i]) );
    }
	
  return (char *)0;
}

static int compare(const void* a, const void* b)
{
  const double *x = (double *)a;
  const double *y = (double *)b;
  if (*x > *y)
    return 1;
  else if (*x < *y)
    return -1;
  return 0;
}

void init_rand_sync_sleep(int s)
{
  init_rand_seed = s;
}

#define VALS_MIN_SIZE (BUF_SIZE)
static void sync_sleep(redisContext *conn)
{
  // if (glob_fun_name && strcmp(glob_fun_name, "wb_generic_manage_orders") == 0) { //DBGDBGDBG
  //   printf("sync_sleep: %lf\n", advance_elapsed_glob);
  //   fflush(stdout);
  // }    
  advance_time(pseudo_barrier(conn, advance_elapsed_glob));
  advance_elapsed_glob = 0;
}

static double from_timespec_to_double(struct timespec *req)
{
  return req->tv_sec + ((double)req->tv_nsec)/1000000000L;
}

void sleep_wrap(redisContext *conn, struct timespec *req)
{
#ifdef SIMULATION_MODE
  lump_time(conn, (const char *)0, req);
#else
  nanosleep(req, (struct timespec *)0);
  printf("slept %lf, now time is %ld\n", from_timespec_to_double(req), time((time_t *)0)); fflush(stdout);
#endif
}

//DIFFERENTIATE BETWEEN SLEEP AND FAKE, IT IS IMPORTANT IN "REAL" MODE...
void lump_time(redisContext *conn, const char *statm_type, struct timespec *req)
{
  // if (glob_fun_name && strcmp(glob_fun_name, "wb_generic_manage_orders") == 0) { //DBGDBGDBG
  //   printf("lump_time: %s %lf\n", statm_type? statm_type : "", req? from_timespec_to_double(req) : -1);
  //   fflush(stdout);
  // }    
#ifdef SIMULATION_MODE
  static pqxx::nontransaction *N = (pqxx::nontransaction *)0;
  static std::mt19937 *gen; // mersenne_twister_engine seeded with rd()
  static std::map<std::string, std::string> times = {};
  double val;
  if (statm_type) {
    if (!N) {
      gen = new std::mt19937(init_rand_seed);
      N = new pqxx::nontransaction(*glob_C);
    }
    if (times.count(statm_type) == 0) {
      assert(sprintf(sql, "SELECT rand_time_type FROM function_time WHERE '%s' SIMILAR TO fname AND statm_type = '%s'", glob_fun_name, statm_type) < BUF_SIZE);
      pqxx::result R2(N->exec(sql));
      if (R2.size() != 1) {
	printf("Error with query: %s\n", sql);
	fflush(stdout);
	assert(0);
      }
      times[statm_type] = strdup(R2[0][0].as<std::string>().c_str());
    }
    if (strstr(times[statm_type].c_str(), "finite_uniform")) {
      double *vals;
      unsigned len;
      char *tmp[2], *for_strtok_r;
      tmp[0] = strdup(times[statm_type].c_str());
      strtok_r(tmp[0], ":", &for_strtok_r);
      tmp[1] = strtok_r((char *)0, ":", &for_strtok_r);
      len = atoi(tmp[1]);
      vals = (double*)calloc(len, sizeof(double));
      for (int i = 0; i < len; i++) {
	tmp[1] = strtok_r((char *)0, ":", &for_strtok_r);
	vals[i] = atof(tmp[1]);
      }
      free(tmp[0]);
      std::uniform_int_distribution<> distrib(0, len - 1);
      val = vals[distrib(*gen)];
      free(vals);
    }
    else if (strstr(times[statm_type].c_str(), "gaussian")) {
      char *tmp[3], *for_strtok_r;
      tmp[0] = strdup(times[statm_type].c_str());
      strtok_r(tmp[0], ":", &for_strtok_r);
      tmp[1] = strtok_r((char *)0, ":", &for_strtok_r);
      tmp[2] = strtok_r((char *)0, ":", &for_strtok_r);
      std::normal_distribution<double> distribution(atof(tmp[1]), atof(tmp[2]));
      free(tmp[0]);
      do {
	val = distribution(*gen);
      } while (val <= 0);
    }
    else
      val = atof(times[statm_type].c_str());
  }
  else 
    val = (double)req->tv_sec + ((double)req->tv_nsec)/(double)1000000000L;
  advance_elapsed_glob += val;
#endif
}

static double pseudo_barrier(redisContext *conn, double t)
{
  double ret;
  assert(sprintf(sql, "%lf", t) < BUF_SIZE);
  redisReply *reply = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, options_also_barrier_glob, "LPUSH %s%s_0 %s", QUEUE_PREFIX, glob_fun_name, sql);
  freeReplyObject(reply);
  reply = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, options_also_barrier_glob, "BRPOP %s%s_1 0", QUEUE_PREFIX, glob_fun_name);
  ret = atof(&reply->element[1]->str[1]);
  freeReplyObject(reply);
  return ret;
}

static redisReply *blocking_read(redisContext *conn, const char *cmd)
{
  redisReply *ret;
  char *q[3];
  q[0] = strdup(cmd);
  strtok_r(q[0], " ", &q[2]);
  q[1] = strtok_r((char *)0, " ", &q[2]);
  redisReply *reply = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, options_also_barrier_glob, "LPUSH %s%s_0 DROP%s", QUEUE_PREFIX, glob_fun_name, q[1]);
  freeReplyObject(reply);
  // printf("DBG:LPUSH %s%s_0 DROP%s\n", QUEUE_PREFIX, glob_fun_name, q[1]); fflush(stdout);
  free(q[0]);
  //the inside_timestamp of this command (receving an Ltime) will be the old one, unavoidable
  reply = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, options_also_barrier_glob, "BRPOP %s%s_1 0", QUEUE_PREFIX, glob_fun_name);
  advance_time(atof(&reply->element[1]->str[1])); // critical runs are possible
  freeReplyObject(reply);
  ret = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, 1, cmd);
  reply = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, options_also_barrier_glob, "LPUSH %s%s_0 ACK", QUEUE_PREFIX, glob_fun_name);
  freeReplyObject(reply);
  lump_time(conn, "recv", (struct timespec *)0);
  return ret;
}

int check_assumptions(double tau_s, double **T, unsigned T_num, unsigned *size_T)
{
  int ret = (tau_s > 0);
  for (int i = 0; ret && (i < T_num); i++)
    for (int j = 0; ret && (j < size_T[i]); j++)
      ret = ret && (T[i][j] > 0);
  return ret;
}

double elapsed_time(int what)
{
  static clock_t begin;
  if (what == 1) {
    begin = clock();
    return 0;
  }
  else
    return (double)(clock() - begin)/CLOCKS_PER_SEC;  
}

// LPUSH channel arg1..argn
// BRPOP channel 0
// RPOP channel
// LLEN channel
redisReply *redis_cmd_wrap(redisContext *conn, const char *fmt, ...)
{
  char *to_pass;
  va_list arg;
  va_start(arg, fmt);
  int dim = vsnprintf((char *)0, 0, fmt, arg);
  va_end(arg);
  to_pass = (char *)calloc(dim + 1, sizeof(char ));
  va_start(arg, fmt);
  vsprintf(to_pass, fmt, arg);
  va_end(arg);
  // if (glob_fun_name && strcmp(glob_fun_name, "wb_generic_manage_orders") == 0) { //DBGDBGDBG
  //   printf("redis_cmd_wrap: ");
  //   va_start(arg, fmt);
  //   vprintf(fmt, arg);
  //   va_end(arg);
  //   printf("\n");
  //   fflush(stdout);
  // }
  char is_send = (to_pass[2] == 'U'), is_bl_read = (to_pass[0] == 'B'), is_read = (to_pass[0] == 'R'), is_llen = (to_pass[1] == 'L'), is_lrange = (to_pass[2] == 'A');
  sync_sleep(conn);
  if (is_llen || is_lrange) {
    redisReply *ret = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, 1, to_pass);
    free(to_pass);
    lump_time(conn, "poll", (struct timespec *)0); //also for range
    return ret;
  }
  if (is_read) {
    char *tmp_to_pass = strdup(to_pass);
    char *tmp_q[3];
    strtok_r(tmp_to_pass, " ", &tmp_q[2]);
    tmp_q[0] = strtok_r((char *)0, " ", &tmp_q[2]);
    tmp_q[1] = strtok_r((char *)0, " ", &tmp_q[2]);
    redisReply *ret = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, options_also_barrier_glob, "LPUSH %s%s_0 RPOP%s|%s", QUEUE_PREFIX, glob_fun_name, tmp_q[0], tmp_q[1]? tmp_q[1] : "1");
    freeReplyObject(ret);
    ret = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, options_also_barrier_glob, "BRPOP %s%s_1 0", QUEUE_PREFIX, glob_fun_name);
    freeReplyObject(ret);
    free(tmp_to_pass);
    ret = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, 1, to_pass);
    free(to_pass);
    lump_time(conn, "recv", (struct timespec *)0);
    return ret;
  }
  if (is_send) {
    char *tmp_q[2];
    strtok_r(to_pass, " ", &tmp_q[1]);
    tmp_q[0] = strtok_r((char *)0, " ", &tmp_q[1]);
    redisReply *ret = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, options_also_barrier_glob, "LPUSH %s%s_0 LPUSH%s", QUEUE_PREFIX, glob_fun_name, tmp_q[0]);
    // printf("DBG:LPUSH %s%s_0 LPUSH%s\n", QUEUE_PREFIX, glob_fun_name, tmp_q[0]); fflush(stdout);
    freeReplyObject(ret);
    free(to_pass);
    ret = (redisReply *)redis_cmd_wrap_psql_only_internal(conn, options_also_barrier_glob, "BRPOP %s%s_1 0", QUEUE_PREFIX, glob_fun_name);
    freeReplyObject(ret);
    char **argv;
    int argc;
    FROM_VARIADIC_TO_ARGV(fmt)
    ret = (redisReply *)redis_cmd_wrap_psql_only_argv(conn, 1, argc, argv);
    for (int i = 0; i < argc; i++) 
      free(argv[i]);
    free(argv);
    lump_time(conn, "send", (struct timespec *)0);
    return ret;
  }
  if (is_bl_read) {
    redisReply *ret = blocking_read(conn, to_pass);
    free(to_pass);
    return ret;
  }
  return (redisReply *)0;
}

static redisReply *redis_cmd_wrap_psql_only_internal(redisContext *conn, int also_wrap, const char *fmt, ...)
{
  char **argv;
  int argc;
  FROM_VARIADIC_TO_ARGV(fmt)
  redisReply *ret = (redisReply *)redis_cmd_wrap_psql_only_argv(conn, also_wrap, argc, argv);
  for (int i = 0; i < argc; i++) 
    free(argv[i]);
  free(argv);
  return ret;
}

pqxx::result *db_cmd(redisContext *conn, pqxx::work *W, pqxx::nontransaction *N, char flags, const char *sql)
{
  // if (glob_fun_name && strcmp(glob_fun_name, "wb_generic_manage_orders") == 0) { //DBGDBGDBG
  //   printf("db_cmd: %s\n", sql);
  //   fflush(stdout);
  // }    
  assert((!W) != (!N));
  pqxx::result *r = (pqxx::result *)0;
  if (sql[0] == '\0') {
    assert(W);
    W->commit();
    return r;
  }
#ifdef SIMULATION_MODE
  if (flags&4)
    elapsed_time(1);
  sync_sleep(conn);
#endif
  if (W) {
    if (flags&1)
      r = new pqxx::result(W->exec(sql));
    else
      W->exec(sql);
    if (flags&2)
      W->commit();
  }
  else {
    r = new pqxx::result(N->exec(sql));
  }
#ifdef SIMULATION_MODE
  if (flags&4)
    printf("DB_STATS: %s --> %lf\n", sql, elapsed_time(0));
  lump_time(conn, sql[0] == 'I'? "insert" : (sql[0] == 'S'? "select" : "update"), (struct timespec *)0);
#endif
  return r;
}

redisReply *redis_cmd_wrap_psql_only(redisContext *conn, double time, const char *fmt, ...)
{
  char **argv;
  int argc;
  advance_time(time);
  FROM_VARIADIC_TO_ARGV(fmt)
  redisReply *ret = (redisReply *)redis_cmd_wrap_psql_only_argv(conn, options_also_barrier_glob, argc, argv);
  for (int i = 0; i < argc; i++) 
    free(argv[i]);
  free(argv);
  return ret;
}
