#ifndef ___CLIB_H_______
#define ___CLIB_H_______
#include <hiredis/hiredis.h>
#include <stdlib.h>
#include <time.h>
#include <stdarg.h>
#include <pqxx/pqxx> 
#include <sys/types.h>
#include <unistd.h>

#define TOLL_DBL 1e-6
#ifdef SIMULATION_MODE
#define redis_cmd redis_cmd_wrap
#define initialize_simulation(c, a, cformat, ...) init_time(c, a, cformat __VA_OPT__(,) __VA_ARGS__)
#else
#define redis_cmd redisCommand
#define initialize_simulation(c, a, cformat, ...) ;
#endif

#ifndef QUEUE_INIT_BARR_SEND
#define QUEUE_INIT_BARR_SEND "work:queue:INIT_BARR_SEND"
#endif
/* #ifndef QUEUE_INIT_BARR_RECV */
/* #define QUEUE_INIT_BARR_RECV "work:queue:INIT_BARR_RECV" */
/* #endif */
#ifndef QUEUE_PREFIX
#define QUEUE_PREFIX "work:queue:"
#endif
#ifndef QUEUE_CO
#define QUEUE_CO "work:queue:CO"
#endif
#ifndef QUEUE_SO
#define QUEUE_SO "work:queue:SO"
#endif
#ifndef QUEUE_MO
#define QUEUE_MO "work:queue:MO"
#endif
#ifndef QUEUE_MMS
#define QUEUE_MMS "work:queue:MMS"
#endif
#ifndef QUEUE_PO
#define QUEUE_PO "work:queue:PO"
#endif
#ifndef QUEUE_C_BASE
#define QUEUE_C_BASE "work:queue:C"
#endif
#ifndef QUEUE_CFS_BASE
#define QUEUE_CFS_BASE "work:queue:CFS"
#endif
#ifndef QUEUE_CFP_BASE
#define QUEUE_CFP_BASE "work:queue:CFP"
#endif
#ifndef QUEUE_SI_BASE
#define QUEUE_SI_BASE "work:queue:SI"
#endif
#ifndef QUEUE_PI_BASE
#define QUEUE_PI_BASE "work:queue:PI"
#endif
#ifndef QUEUE_CI_BASE
#define QUEUE_CI_BASE "work:queue:CI"
#endif
#ifndef QUEUE_TERM
#define QUEUE_TERM "work:queue:TERM"
#endif

#ifndef CONFIG_FILE_PATH
#define CONFIG_FILE_PATH "config.txt"
#endif

redisContext *conn_to_redis(char **argv);
/* void set_env_db(); */
void from_double_to_timespec(struct timespec *req, double t);
void print_all(int, const char *, ...);
void *limit_saturate_f(void *(*f)(void *), void *arg, double t, int *res, double *);
char *hostname_to_ip(const char * hostname);
/* void sync_sleep(redisContext *conn); */
void sleep_wrap(redisContext *conn, struct timespec *req);
void lump_time(redisContext *conn, const char *statm_type, struct timespec *req);
/* char *blocking_read(redisContext *conn, const char *queue); */
int check_assumptions(double tau_s, double **T, unsigned T_num, unsigned *size_T);
void init_time(redisContext *, char , const char *, ...);
char *get_curr_time_psql();
void init_rand_sync_sleep(int s);
void check_time_here(redisContext *conn, char *msg, const char *);
double elapsed_time(int);
time_t get_time();
void terminate_time(redisContext *conn);
void before_blocking(redisContext *conn);
void after_blocking(redisContext *conn);
redisReply *redis_cmd_wrap(redisContext *conn, const char *, ...);
//flags[0] = 1 --> return the result (only considered if W, otherwise always return)
//flags[1] = 1 --> also commit (only considered if W, otherwise never commit)
//flags[2] = 1 --> stats
//sql == "" --> only commit
pqxx::result *db_cmd(redisContext *conn, pqxx::work *W, pqxx::nontransaction *N, char flags, const char *sql);
redisReply *redis_cmd_wrap_psql_only(redisContext *conn, double, const char *fmt, ...);
#endif
