import common_lib
import sys
import argparse
import datetime
import os
import json
import redis
import more_itertools
import random
import math

def main():
    args = parse_args()
    common_lib.init_rand(args.rand_seed)
    rc = redis.Redis(host=args.redishost, port=args.redisport, decode_responses=True)
    fun_name = "shipper_env_" + str(args.index_ship)
    common_lib.init_time(rc, False, fun_name)
    common_lib.redis_command(rc, "LPUSH " + args.queue_so + " init " + str(args.index_ship))
    while True:
        X = common_lib.redis_command(rc, "RPOP " + args.queue_t_base + str(args.index_ship))
        if X != None:
            common_lib.redis_command(rc, "LPUSH " + args.queue_so + " term " + str(args.index_ship))
            common_lib.terminate_time(rc)
            print(common_lib.fun_name_glob + " exited because asked")
            sys.stdout.flush()
            sys.exit(0)
        X = common_lib.redis_command(rc, "RPOP " + args.queue_si_base + str(args.index_ship))
        if X != None:
            Xar = X.split()
            for l in range(0, len(Xar), 3):
                i = int(Xar[l])
                n = int(Xar[l + 2])
                o = int(Xar[l + 1])
                # print("Waiting shipped")
                # sys.stdout.flush()
                common_lib.sleep_wrap(rc, cause="ship_time")
                common_lib.redis_command(rc, "LPUSH " + args.queue_so + " " + str(o) + " " + str(args.index_ship))
        # print("About to sleep")
        # sys.stdout.flush()
        common_lib.sleep_wrap(rc, cause="main_sleep")

def parse_args():
    QUEUE_SO_DEF = "work:queue:SO"
    QUEUE_SI_BASE_DEF = "work:queue:SI"
    QUEUE_T_BASE_DEF = "work:queue:TS"
    DELIV_TIME_DEF = "3600"
    INDEX_SHIP_DEF = 0
    RAND_SEED_DEF = 10

    parser = argparse.ArgumentParser(description='Command arguments')
    parser.add_argument("-r", "--rand_seed", dest = "rand_seed", help = "rand_seed value (default is " + str(RAND_SEED_DEF) + ")", default = RAND_SEED_DEF, type = int)
    parser.add_argument("-q", "--queue_so", dest = "queue_so", help = "queue_so value (default is " + str(QUEUE_SO_DEF) + ")", default = QUEUE_SO_DEF, type = str)
    parser.add_argument("-Q", "--queue_si_base", dest = "queue_si_base", help = "queue_si_base value (default is " + str(QUEUE_SI_BASE_DEF) + ")", default = QUEUE_SI_BASE_DEF, type = str)
    parser.add_argument("-t", "--queue_t_base", dest = "queue_t_base", help = "queue_t_base value (default is " + str(QUEUE_T_BASE_DEF) + ")", default = QUEUE_T_BASE_DEF, type = str)
    parser.add_argument("-d", "--deliv_time", dest = "deliv_time", help = "deliv_time value (default is " + str(DELIV_TIME_DEF) + ")", default = DELIV_TIME_DEF, type = str)
    parser.add_argument("-i", "--index_ship", dest = "index_ship", help = "index_ship value (default is " + str(INDEX_SHIP_DEF) + ")", default = INDEX_SHIP_DEF, type = int)
    parser.add_argument("redishost", help = "redishost", type = str)
    parser.add_argument("redisport", help = "redisport", type = str)

    common_lib.print_cmd_line(sys.argv)
    args = parser.parse_args()

    if args.queue_so == "":
        print("Error: queue_so (-q) must not be the empty string")
        sys.exit(2)

    if args.queue_si_base == "":
        print("Error: queue_si_base (-Q) must not be the empty string")
        sys.exit(2)

    if args.queue_t_base == "":
        print("Error: queue_t_base (-t) must not be the empty string")
        sys.exit(2)

    if args.deliv_time == "":
        print("Error: deliv_time (-d) must not be the empty string")
        sys.exit(2)

    if args.index_ship < 0:
        print("Error: index_ship (-i) must not be negative")
        sys.exit(2)

    common_lib.print_all_options(args)
    return args
    
main()
