#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "aux.h"
#include <hiredis/hiredis.h>
#include <time.h>
#include <math.h>
#include <assert.h>
#include "clib.h"
#include <pqxx/pqxx> 

#define ALSO_REGISTER 0

int main(int argc, char **argv) {
  redisContext *conn;
  redisReply *reply;
  if (argc != 11) {
    printf("\nUsage: %s redis_ip_address redis_ip_port psql_dbname psql_user psql_password psql_host psql_port result_file tmax t\n\n", argv[0]);
    exit(2);
  }
  printf("Invoked with cmdline\n\t");
  for (int i = 0; i < argc; i++)
    printf("%s ", argv[i]);
  printf("\n");
  fflush(stdout);
  char buffer[1024], *tmp;
  tmp = hostname_to_ip(argv[6]);
  sprintf(buffer, "dbname = %s user = %s password = %s hostaddr = %s port = %s", argv[3], argv[4], argv[5], tmp, argv[7]);
  free(tmp);
  pqxx::connection C(buffer);
  conn = conn_to_redis(argv);
  initialize_simulation(conn, ALSO_REGISTER, "int_monitor");
  FILE *f = fopen(argv[8], "w");
  if (!f) {
    perror("Unable to open file");
    exit(3);
  }
  fprintf(f, "order_id|customer_id|item_id|how_many|date_placed|date_processed|date_ready|date_shipped|date_arrived|reason\n");
  fflush(f);
  struct timespec req;
  from_double_to_timespec(&req, atof(argv[10]));
  while (1) {
    aux_monitor(conn, &C, f, atof(argv[9]));
    sleep_wrap(conn, &req);
  }
  fclose(f);

  /* Disconnects and frees the context */
  redisFree(conn);
  print_all(1, "Internal monitor exiting\n");
  return 0;
}
