#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "aux.h"
#include <hiredis/hiredis.h>
#include <time.h>
#include <math.h>
#include <assert.h>
#include "clib.h"
#include <pqxx/pqxx> 

#define ALSO_REGISTER 0

int main(int argc, char **argv) {
  redisContext *conn;
  redisReply *reply;
  if (argc != 10) {
    printf("\nUsage: %s what_it_is redis_ip_address redis_ip_port psql_dbname psql_user psql_password psql_host psql_port t\n\n", argv[0]);
    exit(2);
  }
  printf("Invoked with cmdline\n\t");
  for (int i = 0; i < argc; i++)
    printf("%s ", argv[i]);
  printf("\n");
  fflush(stdout);
  char buffer[1024], *tmp;
  tmp = hostname_to_ip(argv[7]);
  sprintf(buffer, "dbname = %s user = %s password = %s hostaddr = %s port = %s", argv[4], argv[5], argv[6], tmp, argv[8]);
  free(tmp);
  pqxx::connection C(buffer);
  conn = conn_to_redis(argv + 1);
  initialize_simulation(conn, ALSO_REGISTER, "%s", argv[1]);
  int type;
  struct timespec req;
  if (strcmp(argv[1], "collect_from_cust") == 0)
    type = 0;
  else if (strcmp(argv[1], "collect_from_prod") == 0)
    type = 1;
  else if (strcmp(argv[1], "collect_from_ship") == 0)
    type = 2;
  else {
    from_double_to_timespec(&req, atof(argv[9]));
    if (strcmp(argv[1], "manage_orders") == 0)
      type = 3;
    else if (strcmp(argv[1], "manage_min_storage") == 0)
      type = 4;
    else if (strcmp(argv[1], "send_orders") == 0)
      type = 5;
    else
      assert(0);
  }
  while (1) {
    manage_reqs(conn, &C, type);
    if (type > 2)
      sleep_wrap(conn, &req);
  }

  /* Disconnects and frees the context */
  redisFree(conn);
  print_all(1, "Seingle handle from work exiting\n");
  return 0;
}
